\NeedsTeXFormat{LaTeX2e}[2009/09/24]
\ProvidesClass{sajl} [2014/08/12 v1.0 LaTeX document class for South American Journal of Logic]

% Toma como base la clase "article.cls"
\LoadClass[12pt]{article}

\usepackage{graphicx,float,multicol}

% Definición de comandos propios de sajl
\newcommand{\volume}[1]{\gdef\@volume{#1}}
\global\let\@volume\@empty
\newcommand{\issue}[1]{\gdef\@issue{#1}}
\global\let\@issue\@empty
\renewcommand{\year}[1]{\gdef\@year{#1}}
\global\let\@year\@empty
\newcommand{\authorname}[1]{\noindent {#1} \newline}
\newcommand{\address}[1]{#1 \newline}
\newcommand{\email}[1]{ \textit{E-mail: }\texttt{#1} \vspace{0.5cm}}
\newcommand{\keywords}[1]{\vspace{0.5cm}\noindent \textbf{Keywords:}\ #1}

% redefinición de la generación del título
\renewcommand*{\title}[2]{\gdef\@shorttitle{#1}\gdef\@title{#2}}
\renewcommand*{\author}[2]{\gdef\@shortauthor{#1}\gdef\@author{#2}}
\renewcommand{\maketitle}{
	\begingroup
    \centering
    \Large\textbf\@title\normalsize\vskip\baselineskip\par
    \@author\vskip\baselineskip\par
  \endgroup
}


% Define el tamaño de página y las márgenes
\usepackage{calc}
\usepackage[letterpaper,top=3cm, left=3cm, right=3cm, bottom=3cm, includehead]{geometry} % incluiyendo encabezados en las márgenes
%\usepackage[letterpaper,top=3cm, left=3cm, right=3cm, bottom=3cm, includehead, includefoot]{geometry} % incluyen encabezados y pié de página en las márgenes

% define los encabezados de las páginas
\@twosidetrue
\renewcommand{\@oddhead}{\hfill \textsc{\@shorttitle} \hfill \thepage}%
\renewcommand{\@evenhead}{\thepage \hfill \textsc{\@shortauthor} \hfill}%
\renewcommand{\@oddfoot}{}%     
\renewcommand{\@evenfoot}{\@oddfoot}%     

% Incluye la información de la revista al comienzo del artículo
\RequirePackage{lastpage}
\AtBeginDocument{%
	\label{FirstPage} 
	{
		\begin{multicols}{2}
		{
			\small
			\thispagestyle{empty}
  		\noindent {\em South American Journal of Logic} \newline
	  	\textsf{Vol. \ifx\@volume\@empty??\relax\else\@volume\fi,  n. \ifx\@issue\@empty??\relax\else\@issue\fi, 
  		pp. \pageref{FirstPage}--\pageref{LastPage}, \ifx\@year\@empty??\relax\else\@year\fi} \newline
  		\textsf{ISSN: 2446-6719} % (Print)  \ \ \textsf{2446-6719} (Online)  
  	}
  	\begin{flushright} 
%	  	\includegraphics[scale=0.05]{logo-sajl1} % valor antigo
	  	\includegraphics[scale=0.083]{logo-sajl1}
	  \end{flushright}
	  \end{multicols}
  	\vspace{1cm}
  }
}

\endinput